import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import noNamespace.MenuSetDocument;
import noNamespace.MenuSetDocument.MenuSet;
import noNamespace.MenuSetDocument.MenuSet.Menu;
import org.antlr.stringtemplate.StringTemplate;
import org.apache.xmlbeans.XmlException;

/**
 * 
 * XMLMSG - XML Messsagebox Script Generator by Aaron Echols (alias is morerunes). Generates messageBox menu scripts for TES IV: Oblivion.
 * Copyright (C) 2009 Aaron Echols
 * 
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the Lesser GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the Lesser GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */

public class MSG {

	/**
	 * @param args
	 * @throws IOException
	 * @throws XmlException
	 */
	public static void main(String[] args) throws XmlException, IOException {

		File inputFile = new File(args[0]);

		MenuSetDocument doc = MenuSetDocument.Factory.parse(inputFile);
		StringTemplate msgTemplate = TemplateLoader.get("MessageboxScript.st",
				"MenuScript");

		MenuSet menuSet = doc.getMenuSet();
		Menu[] tesMenus = menuSet.getMenuArray();

		for (int i = 0; i < tesMenus.length; i++) {
			Menu menu = tesMenus[i];
			if (menu.getId() == (menuSet.getMainMenu())) {
				msgTemplate.setAttribute("MainMenuIndex", -(i + 1));
				break;
			}
		}
		msgTemplate.setAttribute("MenuScriptName", menuSet.getScriptName());
		msgTemplate.setAttribute("menus", tesMenus);

		String outputFileName = menuSet.getScriptName() + ".tes";

		PrintWriter fileOut = new PrintWriter(outputFileName);

		fileOut.println(msgTemplate);
		fileOut.flush();
		fileOut.close();
	}
}