group MessageboxScript;

$!
 * 
 * XMLMSG - XML Messsagebox Script Generator by Aaron Echols (alias is morerunes). Generates messageBox menu scripts for TES IV: Oblivion.
 * Copyright (C) 2009 Aaron Echols
 * 
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the Lesser GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the Lesser GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 * 
!$

MenuScript(MenuScriptName,MainMenuIndex,menus,menuVars,giveItem) ::= <<
scn $MenuScriptName$

short Choice
short currentMenu
Begin OnActivate
set currentMenu to $MainMenuIndex$
End

Begin GameMode
$menus:whichMenu()$
if currentMenu > 0 && Choice == -1
	set Choice to GetButtonPressed
endif
$menus:menuCode()$
End
>>

whichMenu(menu) ::=<<
if (currentMenu == -$menu.id$) 
	MessageBox "$menu.title$"$menu.buttonArray:buttonList()$ 
	set currentMenu to $menu.id$
endif

>>

buttonList() ::=<< "$it.title$">>

buttonCode(buttons) ::=<<
$first(buttons):{ button | 
	if (Choice == $i0$)
	set Choice to -1
	$if(button.setCode)$
$button.code$$endif$
	$if(button.setClose)$
	set currentMenu to 0
	$elseif(button.setTarget)$
	set currentMenu to -$button.target$
	$else$
	set currentMenu to -$menu.id$$endif$
	}$
$rest(buttons):{ button |
	elseif (Choice == $i$)
	set Choice to -1
	$if(button.setCode)$
$button.code$$endif$
	$if(button.setClose)$
	set currentMenu to 0
	$elseif(button.setTarget)$
	set currentMenu to -$button.target$
	$else$
	set currentMenu to -$menu.id$$endif$
	}$
	endif
endif
>>

menuCode(menu) ::=<<

if (currentMenu == $i$)
$buttonCode(menu.buttonArray)$ 
>>