import java.io.InputStreamReader;

import org.antlr.stringtemplate.StringTemplate;
import org.antlr.stringtemplate.StringTemplateGroup;
import org.antlr.stringtemplate.language.DefaultTemplateLexer;

public class TemplateLoader {

	private StringTemplate getTemplate(String fileName, String templateName) {
		StringTemplateGroup templateGroup = new StringTemplateGroup(
				new InputStreamReader(this.getClass().getResourceAsStream(
						fileName)), DefaultTemplateLexer.class);
		return templateGroup.getInstanceOf(templateName);
	}

	/**
	 * Loads a String template given the file name and the template name
	 * 
	 * @param fileName
	 * @param templateName
	 * @return
	 */
	public static StringTemplate get(String fileName, String templateName) {
		return instance.getTemplate(fileName, templateName);
	}

	private static final TemplateLoader instance = new TemplateLoader();

	private TemplateLoader() {

	}
}
